<?xml version="1.0"?>
<!-- 2017 Andreas Hense
     Remove double "complete" events in YAWL logs -->
<xsl:stylesheet version="1.0" 
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		xmlns:xes="http://code.deckfour.org/xes">

  <!-- This rule copies everything if the second rule does not match -->  
  <xsl:template match="@*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|node()" />
    </xsl:copy>
  </xsl:template>

  <!-- Finds all "complete" events and copies them only if they are directly followed by
       a second complete event for the same work item -->
  <xsl:template match="xes:event[xes:string[@key='lifecycle:transition'
		       and @value='complete']]" >
    <xsl:variable name="task" select="xes:string[@key='concept:name']/@value" />
    <xsl:if test="following-sibling::xes:event[1]
		  [xes:string[@value=$task]]
		  [xes:string[@key='lifecycle:transition' and @value='complete']]">
      <xsl:copy>
	<xsl:apply-templates select="@*|node()" />
      </xsl:copy>
    </xsl:if>
  </xsl:template>
</xsl:stylesheet>

